/*!
 * @file grid.h
 * @brief Definition of ...
*/

#ifndef _GRID_H
#define _GRID_H

#include "vertex_array_model.h"

// FORWARD DECLARATION



//! A class for ...
class Grid : public VertexArrayModel
{

public:
  Grid(float sizeX, float sizeY, unsigned int resolutionX, unsigned int resolutionY);
  virtual ~Grid();

  void setSizeX(float sizeX) { this->_sizeX = sizeX; };
  void setSizeY(float sizeY) { this->_sizeY = sizeY; };

  float sizeX() const { return this->_sizeX; };
  float sizeY() const { return this->_sizeY; };
  unsigned int rows() const { return this->_rows; };
  unsigned int columns() const { return this->_columns; };

  float& height(unsigned int row, unsigned int column);

private:
  float             _sizeX;
  float             _sizeY;

  unsigned int      _rows;
  unsigned int      _columns;
};

#endif /* _GRID_H */
